#include <stdlib.h>
#include <time.h>
#include <iostream>
#include "includes/medianfilter.h"
#include <sstream>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <algorithm>
#include <fstream>
#include <sndfile.h>
#include <signal.h>
#include <vector>

using namespace std;

struct diferencias{
	vector<double> diffs;
};

void proc(string file, string methodpitch){

	
        string filename, f0filename, procfilename, diffilename,  ss;
	ostringstream systemstring;
			filename = file;
			    
			    f0filename = filename.substr(0, filename.length()-4);
	 		    f0filename = f0filename + ".f0";
			    procfilename = filename.substr(0, filename.length()-4);
			    procfilename = procfilename + ".proc";
			    diffilename = filename.substr(0, filename.length()-4);
			    diffilename = diffilename + ".diff"; 
			    //cout << "---file readed" << endl;
		if(methodpitch == "-esps"){ methodpitch = "";}
		//Extracting pitch
			    systemstring << "./getf0snack "<< methodpitch <<" -f 51 -F 900 " << filename << " " << f0filename << endl;
			    ss = systemstring.str();
			    system(ss.c_str());
			   //cout << "---pitch extracted" << endl;
			
		//Removing silences
			  systemstring.str("");
			   systemstring << "sed -i '/0.0/d' " << f0filename << endl;
			  ss = systemstring.str();
	                   system(ss.c_str());	
			  // cout << "---silences removed" << endl;

		//Median filter
			   fstream f(f0filename.c_str(), fstream::in | fstream::out);
			   string content;
			   float fl;
			   vector <float> vf;
			   	
			   while(f >> content){
				sscanf(content.c_str(), "%e", &fl);
				vf.push_back(fl);
				
	     
			   }
			   f.close();
			   medianflt(vf, vf, 3);
		          // cout << "---median filter applied" << endl;
			   
		//Downsampling
			   vector <float> vfdown;
			
				
			   for(unsigned i = 0; i < vf.size(); i = i+3){
				vfdown.push_back(vf.at(i));
				
			   }

			  // cout << "---downsampled" << endl;

		//f2midi
			  vector <float> vmidi;
			
			  for(unsigned i = 0; i < vfdown.size(); i++){
				vmidi.push_back(69 + 12*log2(vfdown.at(i)/440));
				
				//vmidi.push_back(1200*log2(vfdown.at(i)/55));
			  }
			//cout << "-- converted to midi" << endl;
		//Segmentation of stable note regions in an audio signal.
			 vector <float> vstable;
			 int winStable = 5;
			 int Thld = 1;
			 bool stable = false;
			 double stdThsld = 0.3;
			 int count = 0;
			 double prevmean, mean;
			 for(unsigned i = winStable; i < vmidi.size(); i++){
				double sum = 0, sq_sum = 0,stdev = 0;				
				for(unsigned j = 0; j < winStable; j++){
					sum += vmidi.at(i-winStable+j);
				}
				
				mean = sum / winStable;
	
				for(unsigned j = 0; j< winStable; j++){
					sq_sum += pow((vmidi.at(i-winStable+j) - mean),2);
				}
				stdev = sqrt(sq_sum/winStable);
				if((stdev < stdThsld) && !stable){
					stable = true;	
					prevmean = mean;	
					count++;		
				}else if((stdev <stdThsld) && stable && (count<Thld)){
					count ++;
				}else if((stdev < stdThsld) && stable && (count>=Thld)){
					count ++;
					vstable.push_back(prevmean);	
							

				}else{
					stable = false;
					count = 0;				
				}				
			 }
			  // cout << "---segmented on stable notes" << endl;

		//Median filter 2

			   medianflt(vstable, vstable, 5);
			   ofstream ff;
			   ff.open(procfilename.c_str());
			   for(unsigned i = 0; i < vstable.size(); i++)
				if(vstable.at(i) < 0){
					ff << 0 << endl;
				}else{
					ff << vstable.at(i) << endl;
				}
			   ff.close();	
			   //cout << "---median filter applied" << endl;

		//Diferencias
			   vector<double> diff;
			   diferencias d;
			   
			   for(unsigned i = 0; i <vstable.size()-1; i++){
			   	diff.push_back((double)vstable.at(i+1) - (double)vstable.at(i));
			   }
			   /*d.diffs = diff;
			   FILE* arch;
			   arch = fopen(diffilename.c_str(), "w+");
			   fwrite(&d, sizeof(d), 1, arch);
			   fclose(arch); */
			   ofstream filedif;
			   filedif.open(diffilename.c_str());
			   for(unsigned i = 0; i < diff.size(); i++)
				filedif << diff.at(i) << endl;
			   filedif.close();	
			  // cout << "---differneces calculated" << endl;

}
