#include <stdlib.h>
#include <time.h>
#include <iostream>
#include "includes/Sock.h"
#include "includes/medianfilter.h"
#include "includes/procesar.h"
#include "includes/dtw_c_diag2.h"
#include <sstream>
#include <stdlib.h>
#include <string.h>
#include <numeric>
#include <math.h>
#include <algorithm>
#include <fstream>

#include <sndfile.h>
#include <signal.h>
#include <vector>

using namespace std;

#define		SAMPLE_RATE			8000
#define 	PORT				3335
#define 	NUMRESULTS			20

ostream & Time(ostream & strm){
    time_t t;
    time(&t);
    strm << ctime(&t);
    return strm;
}

struct Result{
	string name;
	double res;
};

bool sortByName(const Result &lhs, const Result &rhs) { return lhs.name < rhs.name; }
bool sortByRes(const Result &lhs, const Result &rhs) { return lhs.res < rhs.res; }

std::string exec(const char* cmd) {
    FILE* pipe = popen(cmd, "r");
    if (!pipe) return "ERROR";
    char buffer[128];
    std::string result = "";
    while(!feof(pipe)) {
    	if(fgets(buffer, 128, pipe) != NULL)
    		result += buffer;
    }
    pclose(pipe);
    return result;
}

int syntax(const char *prog_name) {
    cerr << prog_name << " port         => server listening to port\n";
    cerr << "Example: " << prog_name << " 2345&\n"; 
    return -1;
}



Sock server; //global to close socked (~Sock()) if ctrl-c pressed
void control_c_exit(int sig) {
  cout << "Exit server ..." << endl; 
  signal(SIGINT, SIG_DFL); //In case it does not exit .. next ctrl-c kills it
  exit(0);
}

int f_server(Sock *sock, void * param) {

long mode;

	while (1) {   
	    sock->read(&mode, sizeof(long), 1);

	    if (mode <= 0){
	    }else{
		break;
	    }
	}

switch (mode){

	case 1:{

		//Modo Login
		long len4;
		string s = "ok\n";
		while (1) {   
			sock->read(&len4, sizeof(long), 1);

			if (len4 <= 0){
				}else{
				break;
			}
		}
		char *user = new char [len4+1];
		sock->read(user, sizeof(char), len4);
		user[len4] = '\0';	
		cout << user << endl;	

		sock->write((const void*)s.c_str(),sizeof(char),s.size());	

		while (1) {   
			sock->read(&len4, sizeof(long), 1);

			if (len4 <= 0){
				}else{
				break;
			}
		}
		char *pass = new char [len4+1];
		sock->read(pass, sizeof(char), len4);
		pass[len4] = '\0';
		cout << pass << endl;
	
		
		
		fstream file("users.txt", fstream::in | fstream::app | fstream::out);

		string aWord;
		bool found = false;
		while(file.good()){
			getline(file, aWord);
			
			if(file.good() && strcmp(aWord.c_str(), user) == 0){
				//user found
				found = true;
				getline(file, aWord);
				getline(file, aWord);
				if(file.good() && strcmp(aWord.c_str(), pass) == 0){
					s = "logincorrecto";
					sock->write((void *)s.c_str(), sizeof(char), s.size());
				}else{
					s = "contraseñamal";
					sock->write((void *)s.c_str(), sizeof(char), s.size());				
				}
			}
		}



		if (!found){
			s = "no";
			sock->write((void *)s.c_str(), sizeof(char), s.size());
			file.close();
			file.open("users.txt", fstream::in | fstream::app | fstream::out);
			file << user << endl;
			file << "0" << endl;
			file << pass << endl;

		}

		cout << "User: " << user << " >> " << s << " --" << Time << endl;
		file.close();
		break;}
	case 2:{
			  long len, len2, len3=0;
			  SNDFILE *sndfile_out;
			  SF_INFO sf_info;
			  ofstream myfile;
			  int n_write=0;
			  int results = 1;

			  sf_info.format = SF_FORMAT_WAV | SF_FORMAT_PCM_16;
			  sf_info.samplerate	= SAMPLE_RATE ;
			  sf_info.channels		= 1;
			  ostringstream audioStream, fileStream, difilename, resultstream, systemstring; 

			  audioStream << "queries/audios/" << Time << ".wav";
			  string filename = audioStream.str();

			  filename.erase(remove(filename.begin(),filename.end(),' '),filename.end());
			  filename.erase(remove(filename.begin(),filename.end(),'\n'),filename.end());
			 
			  string tfilename = filename.substr(15, filename.length()-19);
			  fileStream << "queries/txt/" << tfilename << ".txt";
			  resultstream << "queries/results/" << tfilename << ".res";
			  difilename << filename.substr(0, filename.length()-4) << ".diff";
			  string diffile = difilename.str();
			  tfilename = fileStream.str();
			  string resultsfilename = resultstream.str();

			 
			  sndfile_out = sf_open(filename.c_str(), SFM_WRITE, &sf_info);

			 
	
			  if (sndfile_out == 0) {
			     cerr << "Error opening output file" << endl;
			     return -1;
			  }
			  cout << "----SERVER: Sock " << sock->get_sock() 
			       << ":\tOpen session at " << Time;
			  cout << "----SERVER: Sock " << sock->get_sock() << ":\t" << filename << endl;
			  cout << "----SERVER: Sock " << sock->get_sock() << ":\t" << tfilename << endl;
			  cout << "----SERVER: Sock " << sock->get_sock() << ":\t" << diffile << endl;

			  while (1) {   
			     sock->read(&len, sizeof(long), 1);

			     if (len <= 0){
			     }else{
			 	break;
			     }
			 }
		  	char *username = new char [len+1];
			sock->read(username, sizeof(char), len);
			username[len] = '\0';

			cout << "----SERVER: Sock " << sock->get_sock() << ":\t" << username << endl;
			       


			  while (1) {
			    //Read command
			   
			   
			    if (sock->read(&len, sizeof(long), 1) <= 0)
				return -1;

			    else if (len < 0){
				break;
			    }

			    else if( len !=0 ){
				results = 0;
				char *data = new char [len];
				sock->read(data, sizeof(char), len);
				//process window
		
				//write file
				n_write = sf_writef_short(sndfile_out, (short *) data, len/2);
			    }
			  }
			  
			 
			    sf_close(sndfile_out);
			     
			     myfile.open(tfilename.c_str());
			   
  			     


			//REading song name
			while (1) {   
			    sock->read(&len, sizeof(long), 1);

			    if (len <= 0){
			    }else{
				break;
			    }
			}
				char *data = new char [len+1];
				sock->read(data, sizeof(char), len);
				data[len] = '\0';
	
				cout << "----SERVER: Sock " << sock->get_sock() << ":\t" << data << endl;
				myfile << data << "\n";
				 myfile << filename << "\n"; 

			    	 myfile << username << "\n";
			 
			//Processing
				proc(filename, "-esps");
				fstream f(diffile.c_str(), fstream::in | fstream::out);
			 	string content;
			   	float fl;
			  	vector <float> diff;
			  	while(f >> content){
				sscanf(content.c_str(), "%e", &fl);
				diff.push_back(fl);
	       
			   }
			   f.close();

			//dtw
			double input1[diff.size()];
			copy(diff.begin(), diff.end(), input1);
			//Indexar database
			 /*  systemstring.str("");
			   systemstring << "ls queries/diff/ > DB.txt" << endl;
			   string ss = systemstring.str();
			   exec(ss.c_str());*/
			//Leemos la DB
			   fstream database("DB.txt", fstream::in | fstream::out);
		  	  
			cout << "****RESULTS****" << endl;


			   ofstream fileres;
			   fileres.open(resultsfilename.c_str());
			  
			   
				 vector<Result> rr;
			   while(database >> content){
				   
			
				   fstream fd(content.c_str(), fstream::in | fstream::out);
				   string content2;
			 	   double ddb;
				   vector<double> v;
				   int i = 0;
				   while(fd >> content2){
				
					sscanf(content2.c_str(), "%lf", &ddb);
					v.push_back(ddb);

				   }
				   fd.close();
				   double input2[v.size()];
				   copy(v.begin(), v.end(), input2);
				   Result r;
				   double res = dtw_c(input1, input2, -1, diff.size(), v.size(), 1);
				   
				string str = content.substr(0, content.length()-5);
				str.append(".txt");
				systemstring.str("");
			   	systemstring << "head -1 "<< str << endl;
			  	string ss = systemstring.str();
			  	r.name = exec(ss.c_str());
				   
				   r.res = res;
				   rr.push_back(r);
				   
				  
			
		   	   }
			cout << resultsfilename << endl;
			sort(rr.begin(), rr.end(), sortByRes);
			for(int i = 0; i < NUMRESULTS; i++){
				cout << rr.at(i).res << "\t" << rr.at(i).name;	
				fileres << rr.at(i).name << rr.at(i).res << "\n";		
			}
			fileres.close();
			sock->write((void *)resultsfilename.c_str(), sizeof(char), resultsfilename.size());
			//Closing socket
	
				cout << "----SERVER: Sock " << sock->get_sock() << " closed!" << endl;

			  return 0;

	
			 

		break;}

	case 3:{

//Modo Resultados
		long len;
		cout << "----SERVER: Sock " << sock->get_sock() << " modoResultados" << endl;
		//REading file
		while (1) {   
		    sock->read(&len, sizeof(long), 1);

		    if (len <= 0){
		    }else{
			break;
		    }
		}
		char *data = new char [len+1];
		sock->read(data, sizeof(char), len);
		data[len] = '\0';
		cout << data << endl;
		fstream file(data, fstream::in | fstream::app | fstream::out);

		string aWord;
		bool found = false;
		while(file.good()){
			getline(file, aWord);
			aWord = aWord + "\n";
			
			sock->write((void *)aWord.c_str(), sizeof(char), aWord.size());
			long len4;
			while (1) {   
				sock->read(&len4, sizeof(long), 1);

				if (len4 <= 0){
				}else{
					break;
				}
			}

		}
		aWord = "end";
		sock->write((void *)aWord.c_str(), sizeof(char), aWord.size());
		break;}

case 4:{

//Modo Resultados
		long len;
		cout << "----SERVER: Sock " << sock->get_sock() << " modoleerTXT" << endl;
		//REading file
		while (1) {   
		    sock->read(&len, sizeof(long), 1);

		    if (len <= 0){
		    }else{
			break;
		    }
		}
		char *data = new char [len+1];
		sock->read(data, sizeof(char), len);
		data[len] = '\0';
		
		ostringstream filestream;
		filestream << "../bdd/q/" << data << ".txt";	
		cout << filestream.str() << endl;
		string datas = filestream.str();
		fstream file(datas.c_str(), fstream::in | fstream::app | fstream::out);

		string aWord;
		bool found = false;
		while(file.good()){
			getline(file, aWord);
			aWord = aWord + "\n";
			
			sock->write((void *)aWord.c_str(), sizeof(char), aWord.size());
			long len4;
			while (1) {   
				sock->read(&len4, sizeof(long), 1);

				if (len4 <= 0){
				}else{
					break;
				}
			}

		}
		aWord = "end";
		sock->write((void *)aWord.c_str(), sizeof(char), aWord.size());
		break;}




	}


  	cout << "----SERVER: Sock " << sock->get_sock() << "----Socketclosed----" << endl;
}



int run_server(int port) {
  
  signal(SIGINT, control_c_exit); //catch ctrl-c

  if (server.listen(port)){
    cerr << "Error initializing server, port already in use" << endl;
    return 1;
  }
  cout << "Server Started!" << endl;
  while (1) {
  
    // ACCEPT Clients
    if (server.accept(f_server, (void *) 0), false)
      cerr << "Error accepting client" << endl;
  }

  return 0;
  

}


int main(int argc, const char **argv) {
  cout << "Starting server..." << endl;

  if (argc == 1)
    run_server(PORT);

  if (argc !=2)
    return syntax(*argv);

  int nport = atoi(argv[1]);

  if (nport <=0)
    return syntax(*argv);

  if (argc == 2)
    run_server(nport);

  return 0;
}




