#include <stdlib.h>
#include <time.h>
#include <iostream>
#include "includes/dtw_c_diag2.h"
#include <sstream>
#include <stdlib.h>
#include <string>
#include <math.h>
#include <algorithm>
#include <fstream>
#include <cctype>
#include <signal.h>
#include <vector>
#include "includes/procesar.h"

using namespace std;

#define 	NUMRESULTS			10

struct Result{
	string name;
	double res;
};

struct diferencias{
	vector<double> diffs;
}diff, diff2;

bool sortByName(const Result &lhs, const Result &rhs) { return lhs.name < rhs.name; }
bool sortByRes(const Result &lhs, const Result &rhs) { return lhs.res < rhs.res; }


int main(int argc, const char **argv) {
  cout << "Processing files..." << endl;

  if (argc == 1)
    cout << "Please enter the files when executing the programm" << endl;

  if (argc <2)
    cout << "Please enter the files when executing the programm" << endl;

  else{
	
	string filename,  diffilename,  name, content, ss, db;
	ostringstream systemstring;
	string method = argv[1];
	db = argv[2];
	float MRR = 0;
	
	systemstring.str("");
	systemstring << "ls "<< db << "*.diff > DB.txt" << endl;
	ss = systemstring.str();
	system(ss.c_str());
	for (int j=3; j<argc; j++){

		    filename = argv[j];
		    cout << filename << endl;
		
		    name = filename.substr( filename.find_last_of("/")+1);
		    name = name.substr(0, name.length()-4);
		    
		    diffilename = filename.substr(0, filename.length()-4);
		    diffilename = diffilename + ".diff"; 	
		 
		     proc(filename, method);


		   fstream f(diffilename.c_str(), fstream::in | fstream::out);
		   string content;
		   float fl;
		   vector <float> vf;
		   while(f >> content){
			sscanf(content.c_str(), "%e", &fl);
			vf.push_back(fl);
       
		   }
		   f.close();

			double input1[vf.size()];

			copy(vf.begin(), vf.end(), input1);
			
		    fstream database("DB.txt", fstream::in | fstream::out);

		    vector<Result> rr;
	
		    while(database >> content){
					
				 //  cout << content << endl;
				   Result r;
				   fstream fd(content.c_str(), fstream::in | fstream::out);
				   string content2;
			 	   double ddb;
				   vector<double> v;
				   int i = 0;
				   while(fd >> content2){
				
					sscanf(content2.c_str(), "%lf", &ddb);
					v.push_back(ddb);

				   }
				   fd.close();
				   double input2[v.size()];
				   copy(v.begin(), v.end(), input2);



			
				double res = dtw_c(input1, input2, -1, vf.size(), v.size(), 1);
				//double res1 = dtw_c(input2, input1, -1, v.size(), vf.size(), 1);

				//if(res < res1){
				   r.name = content;
				   r.res = res;
				   rr.push_back(r);
				/*}else{
				   r.name = content;
				   r.res = res1;
				   rr.push_back(r);
				}*/
				  
		    }
	 		sort(rr.begin(), rr.end(), sortByRes);
			//if DB = queries de Pau//

			name = filename.substr( filename.find_last_of("/")+1);
			name = name.substr(0, name.length()-4);
			int rank = 0;
			for(int i = 0; i < NUMRESULTS; i++){
				rank = i+1;
				cout << "#" << i+1 << "<-- " << rr.at(i).res << " <-- " << rr.at(i).name << endl;
				string dbname = rr.at(i).name.substr( rr.at(i).name.find_last_of("/")+1);
		  		dbname = dbname.substr(0, dbname.length()-5);
				
					if(isdigit(dbname[dbname.length()-1]))
						dbname = dbname.substr(0, dbname.length()-1);
					if(isdigit(name[name.length()-1]))
						name = name.substr(0, name.length()-1);
				
					if(!dbname.compare(name)){
						break;
					}
				

			}
			float aux = (float) 1/ (float) rank;
			
			MRR = MRR + (aux);
					
	}

	MRR = MRR/(float) (argc-3);
	cout << "***********MRR:" << MRR << "***********" <<endl;

  }
}
